public class Especie{
    // <<Atributos de instancia>>
    protected String nombre;
    protected int machos;
    protected int hembras;
    protected float ritmo;
    // <<Constructor>>
    public Especie(String nom){
        nombre = nom;
    }
    
    // <<Comandos>>
    public void establecerHembras(int h){ 
        if (h>0) hembras = h ; 
    } 
    public void establecerMachos(int m) { 
        if (m>0) machos = m; 
    }
    public void establecerRitmo(float r){ 
        ritmo = r; 
    }
    public void actualizarHembras(int h){
        hembras += h;
        if(hembras<0)
            hembras=0;
    }
    public void actualizarMachos(int m){
        machos += m;
        if (machos<0)
            machos=0;
    }
    public void actualizarRitmo(float r){ 
        ritmo += r;
    }
    
    // <<Consultas>>
    public float obtenerRitmo(){
        return ritmo;
    }
    public String obtenerNombre(){
        return nombre;
    }
    public int obtenerHembras(){
        return hembras;
    }
    public int obtenerMachos(){
        return machos;
    }
    
    
    public int poblacionActual(){ 
        return hembras+machos; 
    }
    public int poblacionEstimada(int anios){
        int poblacion_estimada = machos+hembras;
        for (int i =0;i<anios;i++)
            poblacion_estimada += poblacion_estimada*ritmo;
        return poblacion_estimada;
    }
    
    public int anios(int poblacion){
        int poblacion_estimada = machos+hembras;
        int anios = 0;
        if (poblacion_estimada<poblacion && ritmo>0)
            while(poblacion_estimada<poblacion){
                poblacion_estimada += poblacion_estimada*ritmo;
                anios++;
            }
        else
            if(poblacion_estimada>poblacion && ritmo<0)
                while(poblacion_estimada>poblacion){
                    poblacion_estimada += poblacion_estimada*ritmo;
                    anios++;
                }
            else if (poblacion_estimada!=poblacion)
                    anios = -1;
        return anios;        
    }
    
    public String riesgo(){
        if (ritmo==0)
            return "amarillo";
        else if(ritmo>0)
            return "verde";
        else
            return "rojo";
    }
    
    public boolean masHembras(){
        return hembras>machos;
    }
    public boolean mayorRitmo(Especie e){
        return ritmo>e.obtenerRitmo();
    }
    
    public Especie clone(){
        Especie e = new Especie(nombre);
        e.establecerHembras(hembras);
        e.establecerMachos(machos);
        e.establecerRitmo(ritmo);
        return e;
    }
    public boolean equals(Especie e){
        return nombre.equals(e.obtenerNombre()) && ritmo==e.obtenerRitmo() && machos==e.obtenerMachos() && hembras==e.obtenerHembras();
    }
    public String toString(){
        return "Especie: "+nombre+" machos: "+machos+" hembras: "+hembras+" ritmo: "+ritmo;
    }
}