public class Fecha{
    // <<Atributos de instancia>>
    private int dia;
    private int mes;
    private int anio;
    
    // <<Constructor>>
    public Fecha(int d, int m, int a){
        dia = d;
        mes = m;
        anio = a;
    }
    
    // <<Comandos>>
    public void establecerDia(int d){
        dia = d;
    }
    public void establecerMes(int m){
        mes = m;
    }
    public void establecerAnio(int a){
        anio = a;
    }
    
    // <<Consultas>>
    public String toString(){
        return dia+"/"+mes+"/"+anio;
    }
    public int obtenerDia(){
        return dia;
    }
    public int obtenerMes(){
        return mes;
    }
    public int obtenerAnio(){
        return anio;
    }
    public boolean esAnterior(Fecha f){
        boolean anterior;
        if (f.obtenerAnio() == anio)
            if (f.obtenerMes() == mes)
                anterior = dia < f.obtenerDia();
            else
                anterior = mes < f.obtenerMes();
        else 
            anterior = anio < f.obtenerAnio();
        return anterior;
    }
    public Fecha sumaDias(int d){
        int dia_nueva_fecha = dia + d;
        int mes_nueva_fecha = mes;
        int anio_nueva_fecha = anio;        
        if (dia_nueva_fecha>dias_del_mes()){
            dia_nueva_fecha = dia_nueva_fecha - dias_del_mes();
            mes_nueva_fecha++;
            if (mes_nueva_fecha>12){
                mes_nueva_fecha = 1;
                anio_nueva_fecha++;
            }
            
        }
        return new Fecha(dia_nueva_fecha, mes_nueva_fecha, anio_nueva_fecha);
    }
    
    public Fecha diaSiguiente(){
        return sumaDias(1);            
    }    
    
    private boolean bisiesto(){
        boolean p = anio%4==0;
        boolean q = anio%100==100;
        boolean r = anio%400==100;
        return p&&(!q || r);
    }
    
    private int dias_del_mes(){
        int dias = 31;        
        if (mes==2)
            if(bisiesto())
                dias = 29;
            else
                dias = 28;
        else if(mes==4 || mes==6 || mes==9 || mes==11)
            dias = 30;
        return dias;   
    }
    
    public boolean equals(Fecha f){
        return dia==f.obtenerDia() && mes==f.obtenerMes() && anio==f.obtenerAnio();
    }
    
}